/* gtxtlen -- return length of hardware text */

#include <stdio.h>
#include "SFSCONFG.h"
#include "dig.h"
#include "digdata.h"
#include "digtable.h"

#define METATEXT	40

float digtextlen(word)
char	*word;
{
	double	len;

	switch (digdata.device) {
	case 'o':
		len = digvtextlen(word,(float)(5.0*METATEXT/digdata.xscale),(float)0.0,1)+
				2.5*METATEXT/digdata.xscale;
		break;
	default:
		if (digtable[digdata.select].textlen)
			len = (*digtable[digdata.select].textlen)(word)/digdata.xscale;
		else
			len = strlen(word)*digdata.chwidth/digdata.xscale;
	}
	return((float)len);
}

int digtextlenp(word)
char	*word;
{
	int	len;

	switch (digdata.device) {
	case 'o':
		len = (int)(digvtextlen(word,(float)(5.0*METATEXT/digdata.xscale),(float)0.0,1)+2.5*METATEXT);
		break;
	default:
		if (digtable[digdata.select].textlen)
			len = (*digtable[digdata.select].textlen)(word);
		else
			len = strlen(word)*digdata.chwidth;
	}
	return(len);
}

#ifdef EMO
main()
{
	char	str[80];
	float	x;

	digstart(DIG_DEFAULT_TERM,NULL,1);
	digscale(1.0,1.0,1);

	strcpy(str,"x");
	digtext(20,0.2,0.75,str);
	x = 0.2 + digtextlen(str);
	digbox(23,0.2,0.75,x,0.75+digdata.chheight/digdata.yscale);

	strcpy(str,"xx xx");
	digtext(20,0.2,0.5,str);
	x = 0.2 + digtextlen(str);
	digbox(23,0.2,0.5,x,0.5+digdata.chheight/digdata.yscale);

	strcpy(str,"ABCDEFGHIJKLMnopqrstuvwxyz0123457890 .,;:+*><]}[{^");
	digtext(20,0.2,0.25,str);
	x = 0.2 + digtextlen(str);
	digbox(23,0.2,0.25,x,0.25+digdata.chheight/digdata.yscale);

	digquit(15);
}
#endif
